'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _web3_tools = require('../utils/web3_tools');

var _Pool = require('../contracts/Pool.json');

var _Pool2 = _interopRequireDefault(_Pool);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/*
Copyright: Ambrosus Inc.
Email: tech@ambrosus.io

This Source Code Form is subject to the terms of the Mozilla Public License, v. 2.0. If a copy of the MPL was not distributed with this file, You can obtain one at https://mozilla.org/MPL/2.0/.

This Source Code Form is “Incompatible With Secondary Licenses”, as defined by the Mozilla Public License, v. 2.0.
*/

var PoolActions = function () {
  function PoolActions(web3, poolsStoreWrapper, headContractAddress) {
    (0, _classCallCheck3.default)(this, PoolActions);

    this.web3 = web3;
    this.headContractAddress = headContractAddress;
    this.poolsStoreWrapper = poolsStoreWrapper;
  }

  (0, _createClass3.default)(PoolActions, [{
    key: 'createPool',
    value: function () {
      var _ref = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee(name, minStake, fee, poolsServiceAddress) {
        var pool;
        return _regenerator2.default.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                _context.next = 2;
                return new this.web3.eth.Contract(_Pool2.default.abi, undefined, {
                  gas: _web3_tools.DEFAULT_GAS,
                  gasPrice: this.web3.utils.toWei('5', 'gwei')
                }).deploy({ data: _Pool2.default.bytecode, arguments: [name, 3, this.web3.utils.toWei('250000', 'ether'), minStake, fee, poolsServiceAddress, this.headContractAddress] }).send({
                  from: this.web3.eth.defaultAccount,
                  gas: _web3_tools.DEFAULT_GAS
                });

              case 2:
                pool = _context.sent;

                console.log(name, ':', pool.options.address);

              case 4:
              case 'end':
                return _context.stop();
            }
          }
        }, _callee, this);
      }));

      function createPool(_x, _x2, _x3, _x4) {
        return _ref.apply(this, arguments);
      }

      return createPool;
    }()
  }, {
    key: 'getList',
    value: function () {
      var _ref2 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee2() {
        var count, pools, _iteratorNormalCompletion, _didIteratorError, _iteratorError, _iterator, _step, address, contract, name, id, active, totalStake;

        return _regenerator2.default.wrap(function _callee2$(_context2) {
          while (1) {
            switch (_context2.prev = _context2.next) {
              case 0:
                _context2.next = 2;
                return this.poolsStoreWrapper.getPoolsCount();

              case 2:
                count = _context2.sent;

                if (!(+count > 0)) {
                  _context2.next = 49;
                  break;
                }

                _context2.next = 6;
                return this.poolsStoreWrapper.getPools(0, count);

              case 6:
                pools = _context2.sent;
                _iteratorNormalCompletion = true;
                _didIteratorError = false;
                _iteratorError = undefined;
                _context2.prev = 10;
                _iterator = pools[Symbol.iterator]();

              case 12:
                if (_iteratorNormalCompletion = (_step = _iterator.next()).done) {
                  _context2.next = 33;
                  break;
                }

                address = _step.value;
                _context2.next = 16;
                return (0, _web3_tools.loadContract)(this.web3, _Pool2.default.abi, address);

              case 16:
                contract = _context2.sent;
                _context2.next = 19;
                return contract.methods.name().call();

              case 19:
                name = _context2.sent;
                _context2.next = 22;
                return contract.methods.id().call();

              case 22:
                id = _context2.sent;
                _context2.next = 25;
                return contract.methods.active().call();

              case 25:
                active = _context2.sent;
                _context2.next = 28;
                return contract.methods.totalStake().call();

              case 28:
                totalStake = _context2.sent;

                console.log(id, active ? 'active' : '      ', name, address, this.web3.utils.fromWei(totalStake, 'ether'));

              case 30:
                _iteratorNormalCompletion = true;
                _context2.next = 12;
                break;

              case 33:
                _context2.next = 39;
                break;

              case 35:
                _context2.prev = 35;
                _context2.t0 = _context2['catch'](10);
                _didIteratorError = true;
                _iteratorError = _context2.t0;

              case 39:
                _context2.prev = 39;
                _context2.prev = 40;

                if (!_iteratorNormalCompletion && _iterator.return) {
                  _iterator.return();
                }

              case 42:
                _context2.prev = 42;

                if (!_didIteratorError) {
                  _context2.next = 45;
                  break;
                }

                throw _iteratorError;

              case 45:
                return _context2.finish(42);

              case 46:
                return _context2.finish(39);

              case 47:
                _context2.next = 50;
                break;

              case 49:
                console.log('No pools found');

              case 50:
              case 'end':
                return _context2.stop();
            }
          }
        }, _callee2, this, [[10, 35, 39, 47], [40,, 42, 46]]);
      }));

      function getList() {
        return _ref2.apply(this, arguments);
      }

      return getList;
    }()
  }, {
    key: 'activate',
    value: function () {
      var _ref3 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee3(address, value) {
        var contract;
        return _regenerator2.default.wrap(function _callee3$(_context3) {
          while (1) {
            switch (_context3.prev = _context3.next) {
              case 0:
                _context3.next = 2;
                return (0, _web3_tools.loadContract)(this.web3, _Pool2.default.abi, address);

              case 2:
                contract = _context3.sent;
                _context3.t0 = console;
                _context3.next = 6;
                return contract.methods.activate().send({ gas: _web3_tools.DEFAULT_GAS, value: value, from: this.web3.eth.defaultAccount });

              case 6:
                _context3.t1 = _context3.sent;

                _context3.t0.log.call(_context3.t0, _context3.t1);

              case 8:
              case 'end':
                return _context3.stop();
            }
          }
        }, _callee3, this);
      }));

      function activate(_x5, _x6) {
        return _ref3.apply(this, arguments);
      }

      return activate;
    }()
  }, {
    key: 'deactivate',
    value: function () {
      var _ref4 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee4(address) {
        var contract;
        return _regenerator2.default.wrap(function _callee4$(_context4) {
          while (1) {
            switch (_context4.prev = _context4.next) {
              case 0:
                _context4.next = 2;
                return (0, _web3_tools.loadContract)(this.web3, _Pool2.default.abi, address);

              case 2:
                contract = _context4.sent;
                _context4.t0 = console;
                _context4.next = 6;
                return contract.methods.deactivate().send({ gas: _web3_tools.DEFAULT_GAS, from: this.web3.eth.defaultAccount });

              case 6:
                _context4.t1 = _context4.sent;

                _context4.t0.log.call(_context4.t0, _context4.t1);

              case 8:
              case 'end':
                return _context4.stop();
            }
          }
        }, _callee4, this);
      }));

      function deactivate(_x7) {
        return _ref4.apply(this, arguments);
      }

      return deactivate;
    }()
  }, {
    key: 'stake',
    value: function () {
      var _ref5 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee5(address, value) {
        var contract;
        return _regenerator2.default.wrap(function _callee5$(_context5) {
          while (1) {
            switch (_context5.prev = _context5.next) {
              case 0:
                _context5.next = 2;
                return (0, _web3_tools.loadContract)(this.web3, _Pool2.default.abi, address);

              case 2:
                contract = _context5.sent;
                _context5.t0 = console;
                _context5.next = 6;
                return contract.methods.stake().send({ gas: _web3_tools.DEFAULT_GAS, value: value, from: this.web3.eth.defaultAccount });

              case 6:
                _context5.t1 = _context5.sent;

                _context5.t0.log.call(_context5.t0, _context5.t1);

              case 8:
              case 'end':
                return _context5.stop();
            }
          }
        }, _callee5, this);
      }));

      function stake(_x8, _x9) {
        return _ref5.apply(this, arguments);
      }

      return stake;
    }()
  }, {
    key: 'unstake',
    value: function () {
      var _ref6 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee6(address, value) {
        var contract;
        return _regenerator2.default.wrap(function _callee6$(_context6) {
          while (1) {
            switch (_context6.prev = _context6.next) {
              case 0:
                _context6.next = 2;
                return (0, _web3_tools.loadContract)(this.web3, _Pool2.default.abi, address);

              case 2:
                contract = _context6.sent;
                _context6.t0 = console;
                _context6.next = 6;
                return contract.methods.unstake(value).send({ gas: _web3_tools.DEFAULT_GAS, from: this.web3.eth.defaultAccount });

              case 6:
                _context6.t1 = _context6.sent;

                _context6.t0.log.call(_context6.t0, _context6.t1);

              case 8:
              case 'end':
                return _context6.stop();
            }
          }
        }, _callee6, this);
      }));

      function unstake(_x10, _x11) {
        return _ref6.apply(this, arguments);
      }

      return unstake;
    }()
  }]);
  return PoolActions;
}();

exports.default = PoolActions;